/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH374 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH374 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* MCS-51ƬCԵUļдʾ, 89C52߸ռĵƬ,ҲATMEL/PHILIPS/SSTȾ1KBڲRAMĵƬ */
/* óʾӲ̵Ķ̷ζԸ̷²
     е/CH374HFT.Cļеǰ600ַʾ,
     ҲԭļCH374HFT.C, ôóʾĿ¼µǰ254ļ
*/
/* CH374INT#Ųòѯʽ, ݸƷʽΪ"DPTR",õٶ,
   ֻʹ512ֽڵⲿRAM, ͬʱΪݻļݻ, ʾûⲿRAMǵƬRAM768ֽڵӦ */

/* ֽΪλдUļ,дٶȽģʽ,ֽģʽдļҪļݻFILE_DATA_BUF,
   ֻܹҪ600ֽڵRAM,ڵƬӲԴޡСҶдٶҪ󲻸ߵϵͳ */


/* C51   CH374HFT.C */
/* LX51  CH374HFT.OBJ , CH374HF6.LIB, C51DPTR1.LIB */
/* OHX51 CH374HFT */

#include <reg52.h>
#include <stdio.h>
#include <string.h>

/* ¶ϸ˵뿴CH374HF6.Hļ */
#define LIB_CFG_INT_EN			0		/* CH374INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */

#define CH374_IDX_PORT_ADDR		0xBDF1	/* CH374˿ڵI/Oַ */
#define CH374_DAT_PORT_ADDR		0xBCF0	/* CH374ݶ˿ڵI/Oַ */
/* ֻʹõƬõ1KBⲿRAM: 0000H-01FFH Ϊ̶д, ֽΪλдļҪļݶдFILE_DATA_BUF */
#define	DISK_BASE_BUF_ADDR		0x0000	/* ⲿRAMĴݻʼַ,ӸõԪʼĻΪSECTOR_SIZE */

#define CH374_INT_WIRE			INT0	/* P3.2, INT0, CH374жINT#,CH374INT#,ڲѯж״̬ */
/* δCH374ж,ôӦȥ,ԶʹüĴѯʽ */

#define NO_DEFAULT_CH374_F_ENUM		1		/* δCH374FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH374_F_QUERY	1		/* δCH374FileQueryʽֹԽԼ */
#define NO_DEFAULT_CH374_RESET		1		/* δCH374ResetʽֹԽԼ */

#include "..\CH374HF6.H"

/* P1.4һLEDڼʾĽ,͵ƽLED,U̲ */
sbit P1_4  = P1^4;
#define LED_OUT_INIT( )		{ P1_4 = 1; }	/* P1.4 ߵƽ */
#define LED_OUT_ACT( )		{ P1_4 = 0; }	/* P1.4 ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ P1_4 = 1; }	/* P1.4 ͵ƽLEDʾ */
sbit P1_5  = P1^5;
/* P1.5һLEDڼʾĽ,͵ƽLED,U̲ʱ */
#define LED_RUN_ACT( )		{ P1_5 = 0; }	/* P1.5 ͵ƽLEDʾ */
#define LED_RUN_INACT( )	{ P1_5 = 1; }	/* P1.5 ͵ƽLEDʾ */
sbit P1_6  = P1^6;
/* P1.6һLEDڼʾĽ,͵ƽLED,Uдʱ */
#define LED_WR_ACT( )		{ P1_6 = 0; }	/* P1.6 ͵ƽLEDʾ */
#define LED_WR_INACT( )		{ P1_6 = 1; }	/* P1.6 ͵ƽLEDʾ */

/* ״̬,ʾ벢ͣ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
/* ,Ӧ÷ԼCH374DiskStatus״̬,CH374DiskConnectѯǰUǷ,UѶϿôµȴU̲ٲ,
   Ĵ:
   1һCH374DiskReady,ɹ,Open,Read/Write,CH374DiskReadyлԶCH374DiskConnect
   2CH374DiskReadyɹ,ôǿнCH374DiskStatusΪDISK_CONNECT״̬,Ȼͷʼ(ȴUCH374DiskConnectCH374DiskReady) */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		CH374DelaymS( 100 );
		LED_OUT_INACT( );
		CH374DelaymS( 100 );
	}
}

/* Ϊprintfgetkeyʼ */
void	mInitSTDIO( )
{
	SCON = 0x50;
	PCON = 0x80;
	TMOD = 0x20;
	TH1 = 0xf3;  /* 24MHz, 9600bps */
	TR1 = 1;
	TI = 1;
}

main( ) {
	UINT8	i, c;
	UINT8	DiskPartCount;
	UINT16	TotalCount;
	UINT8	code *pCodeStr;
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	CH374DelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

	i = CH374LibInit( );  /* ʼCH374CH374оƬ,ɹ0 */
	mStopIfError( i );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk\n" );
		while ( 1 ) {  /* ֧USB-HUB,ӵĴοEXAM1EXAM13 */
			CH374DelaymS( 10 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) == ERR_SUCCESS ) break;  /* ѯʽ: ǷӲ´״̬,سɹ˵ */
		}
		LED_OUT_ACT( );  /* LED */
		CH374DelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* UǷ׼,ЩU̲Ҫһ,ĳЩU̱Ҫִһܹ */
		for ( i = 0; i < 5; i ++ ) {  /* еUǷδ׼,Ա */
			CH374DelaymS( 100 );
			printf( "Ready ?\n" );
			if ( CH374DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
		}
		if ( CH374DiskStatus <= DISK_CONNECT ) continue;  /* ֧USB-HUB */

/* ѯ */
/*		printf( "DiskSize\n" );
		i = CH374DiskSize( );  
		mStopIfError( i );
		printf( "TotalSize = %u MB \n", (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec >> 11 ) );  ʾΪMBΪλ
*/
		LED_RUN_ACT( );  /* ʼU */

	for ( DiskPartCount = 0; DiskPartCount < 7; DiskPartCount ++ ) {  /* δӲ̵Ĵ̷,֧7 */

		if ( DiskPartCount ) {  /* ״ν˵Ҫһ̷ */
//			if ( CH374DiskStatus > DISK_MOUNTED )  /* ״νʱǳ */
				CH374DiskStatus = DISK_MOUNTED;  /* ״νʱCH374DiskStatus<DISK_MOUNTEDνʱ */
			if ( CH374v03 == 0 ) break;  /* ֱ߼,ûд̷,ǿƷ᷵ERR_TYPE_ERRORERR_BPB_ERRORERR_FAT_ERRORȴ */
			CH374v03 = 0x12345678 | ( DiskPartCount + 1 );  /* ָҪõĴ̷ */
		}
		else { };  /* ״ν밴 */

/* ȡԭļ */
		printf( "Open\n" );
		strcpy( mCmdParam.Open.mPathName, "/CH374HFT.C" );  /* ļ,ļڸĿ¼ */
		i = CH374FileOpen( );  /* ļ */
		if ( i == ERR_MISS_DIR || i == ERR_MISS_FILE ) {  /* ûҵļ */
/* гļ */
			if ( i == ERR_MISS_DIR ) pCodeStr = "/*";  /* гĿ¼µļ */
			printf( "List file %s\n", pCodeStr );
			for ( c = 0; c < 254; c ++ ) {  /* ǰ254ļ,Ҫ255ļοEXAM1EXAM0 */
				strcpy( mCmdParam.Open.mPathName, pCodeStr );  /* ļ,*Ϊͨ,ļĿ¼ */
/* һöٷǣ˴cΪ0xFFȻöŴCH374vFileSizeУӶ254ļ02147483647 */
				i = strlen( mCmdParam.Open.mPathName );
				mCmdParam.Open.mPathName[ i ] = c;  /* ַȽ滻Ϊ,0254 */
				i = CH374FileOpen( );  /* ļ,ļкͨ*,Ϊļ */
				if ( i == ERR_MISS_FILE ) break;  /* Ҳƥļ,Ѿûƥļ */
				if ( i == ERR_FOUND_NAME ) {  /* ͨƥļ,ļ· */
					printf( "  match file %03d#: %s\n", (unsigned int)c, mCmdParam.Open.mPathName );  /* ʾźƥļĿ¼ */
					continue;  /* һƥļ,´ʱŻ1 */
				}
				else {  /*  */
					mStopIfError( i );
					break;
				}
			}
		}
		else {  /* ҵļ߳ */
			mStopIfError( i );
			TotalCount = 600;  /* ׼ȡܳ */
			printf( "ļжǰ%dַ:\n",TotalCount );
			while ( TotalCount ) {  /* ļȽϴ,һζ,ٵCH374ByteReadȡ,ļָԶƶ */
				if ( TotalCount > MAX_BYTE_IO ) c = MAX_BYTE_IO;  /* ʣݽ϶,ƵζдĳȲܳ sizeof( mCmdParam.ByteRead.mByteBuffer ) */
				else c = TotalCount;  /* ʣֽ */
				mCmdParam.ByteRead.mByteCount = c;  /* ʮֽ */
				i = CH374ByteRead( );  /* ֽΪλȡݿ,ζдĳȲܳMAX_BYTE_IO,ڶεʱŸղŵ */
				mStopIfError( i );
				TotalCount -= mCmdParam.ByteRead.mByteCount;  /* ,ȥǰʵѾַ */
				for ( i=0; i!=mCmdParam.ByteRead.mByteCount; i++ ) printf( "%C", mCmdParam.ByteRead.mByteBuffer[i] );  /* ʾַ */
				if ( mCmdParam.ByteRead.mByteCount < c ) {  /* ʵʶַҪַ,˵ѾļĽβ */
					printf( "\n" );
					printf( "ļѾ\n" );
					break;
				}
			}
			printf( "Close\n" );
			i = CH374FileClose( );  /* رļ */
			mStopIfError( i );
		}
	}

		LED_RUN_INACT( );
		printf( "Take out\n" );
		while ( 1 ) {  /* ֧USB-HUB */
			CH374DelaymS( 10 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) != ERR_SUCCESS ) break;  /* ѯʽ: ǷӲ´״̬,سɹ˵ */
		}
		LED_OUT_INACT( );  /* LED */
		CH374DelaymS( 200 );
	}
}
