/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH374 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH374 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* MCS-51ƬCԵUļдʾ, 89C52߸ռĵƬ */
/* ʾADCģɼݱ浽UļMY_ADC.TXT */
/* CH374INT#Ųòѯʽ, ݸƷʽΪ"DPTR",ٶȽ,MCS51Ƭ,
   ΪλдUļ,дٶȽֽģʽ,
   ģʽΪλ,ҪݵӦ,ֽģʽ,
   ʾģʽ´,ͬʱ˲ͽϸٶ,Ҫļݻ */


/* C51   CH374HFT.C */
/* LX51  CH374HFT.OBJ , CH374HF6.LIB, C51DPTR1.LIB */
/* OHX51 CH374HFT */

#include <reg52.h>
#include <stdio.h>
#include <string.h>

/* ¶ϸ˵뿴CH374HF6.Hļ */
#define LIB_CFG_INT_EN			0		/* CH374INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */

#define CH374_IDX_PORT_ADDR		0xBDF1	/* CH374˿ڵI/Oַ */
#define CH374_DAT_PORT_ADDR		0xBCF0	/* CH374ݶ˿ڵI/Oַ */
/* 62256ṩ32KBRAMΪ: 0000H-01FFHΪ̶д, 0200H-7FFFHΪļݻ */
#define	DISK_BASE_BUF_ADDR		0x0000	/* ⲿRAMĴݻʼַ,ӸõԪʼĻΪSECTOR_SIZE */

#define CH374_INT_WIRE			INT0	/* P3.2, INT0, CH374жINT#,CH374INT#,ڲѯж״̬ */
/* δCH374ж,ôӦȥ,ԶʹüĴѯʽ */

//#define DISK_BASE_BUF_LEN		2048	/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
/* ҪôݻԽԼRAM,ôɽDISK_BASE_BUF_LENΪ0Խֹ.Hļж建,ӦóڵCH375Init֮ǰõĻʼַpDISK_BASE_BUF */

#define NO_DEFAULT_CH374_F_ENUM		1		/* δCH374FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH374_F_QUERY	1		/* δCH374FileQueryʽֹԽԼ */
#define NO_DEFAULT_CH374_RESET		1		/* δCH374ResetʽֹԽԼ */

#include "..\CH374HF6.H"

UINT8X	my_buffer[ 0x3E00 ];			/* ⲿRAMļݻ,ȲСһζдݳ,ҪС0x400 */
/* ׼ʹ˫д,ôڲַָ */

/* P1.4һLEDڼʾĽ,͵ƽLED,U̲ */
sbit P1_4  = P1^4;
#define LED_OUT_INIT( )		{ P1_4 = 1; }	/* P1.4 ߵƽ */
#define LED_OUT_ACT( )		{ P1_4 = 0; }	/* P1.4 ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ P1_4 = 1; }	/* P1.4 ͵ƽLEDʾ */
sbit P1_5  = P1^5;
/* P1.5һLEDڼʾĽ,͵ƽLED,U̲ʱ */
#define LED_RUN_ACT( )		{ P1_5 = 0; }	/* P1.5 ͵ƽLEDʾ */
#define LED_RUN_INACT( )	{ P1_5 = 1; }	/* P1.5 ͵ƽLEDʾ */
sbit P1_6  = P1^6;
/* P1.6һLEDڼʾĽ,͵ƽLED,Uдʱ */
#define LED_WR_ACT( )		{ P1_6 = 0; }	/* P1.6 ͵ƽLEDʾ */
#define LED_WR_INACT( )		{ P1_6 = 1; }	/* P1.6 ͵ƽLEDʾ */

/* ״̬,ʾ벢ͣ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
/* ,Ӧ÷ԼCH374DiskStatus״̬,CH374DiskConnectѯǰUǷ,UѶϿôµȴU̲ٲ,
   Ĵ:
   1һCH374DiskReady,ɹ,Open,Read/Write,CH374DiskReadyлԶCH374DiskConnect
   2CH374DiskReadyɹ,ôǿнCH374DiskStatusΪDISK_CONNECT״̬,Ȼͷʼ(ȴUCH374DiskConnectCH374DiskReady) */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		CH374DelaymS( 200 );
		LED_OUT_INACT( );
		CH374DelaymS( 200 );
	}
}

/* Ϊprintfgetkeyʼ */
void	mInitSTDIO( )
{
	SCON = 0x50;
	PCON = 0x80;
	TMOD = 0x21;
	TH1 = 0xf3;  /* 24MHz, 9600bps */
	TR1 = 1;
	TI = 1;
}

UINT16	total;	/* ¼ǰеݳ */

/* ׼дU̵ݽмл,ϳɴݿʱͨCH374дU */
/* ĺô: ٶ(ΪݿдʱЧʸ), U(Uڲڴ,Ƶд) */
void	mFlushBufferToDisk( UINT8 force )
/* force = 0 Զˢ(黺еݳ,д,ʱڻ), force != 0 ǿˢ(ܻежٶд,ͨϵͳػǰӦǿд) */
{
	UINT8	i;
	UINT32	NewSize;
	if ( force ) {  /* ǿˢ */
		mCmdParam.WriteX.mSectorCount = ( total + CH374vSectorSize - 1 ) / CH374vSectorSize;  /* еֽתΪ(CH374vSectorSize),ȼCH374vSectorSize-1ȷдͷ */
		mCmdParam.WriteX.mDataBuffer = my_buffer;  /*  */
		i = CH374FileWriteX( );  /* Ϊλļд,д뻺е,ͷ */
		mStopIfError( i );
/* ЩUܻ̿Ҫдݺȴһܼ,,ĳЩUзݶʧ,ÿдݺʱټ */
		CH374DelaymS( 1 );  /* дʱ,ѡ,U̲Ҫ */
		memcpy( my_buffer, & my_buffer[ total & ~ ( CH374vSectorSize - 1 ) ], total & ( CH374vSectorSize - 1 ) );  /* ղдU̵ͷݸƵͷ */
		total &= CH374vSectorSize - 1;  /* ֻʣ¸ղдU̵ͷ,ڻΪ˷Ժ׷ */
		if ( total ) NewSize = CH374vFileSize - CH374vSectorSize + total;  /* Ϊλ,ͷ,ļ(Чݵĳ) */
		else NewSize = CH374vFileSize;  /* Ϊλ,ûͷ,ļCH374vSectorSizeı */
		mCmdParam.Modify.mFileSize = NewSize;   /* : µļ,ģʽ漰ͷݲԶ³ */
		mCmdParam.Modify.mFileAttr = 0xff;  /* : µļ,Ϊ0FFH޸ */
		mCmdParam.Modify.mFileTime = 0xffff;  /* : µļʱ,Ϊ0FFH޸ */
		mCmdParam.Modify.mFileDate = 0xffff;  /* : µļ,Ϊ0FFH޸ */
		i = CH374FileModify( );   /* ޸ĵǰļϢ,޸ļ */
		mStopIfError( i );
		printf( "Current file size is %ld\n", CH374vFileSize );
		mCmdParam.Locate.mSectorOffset = 0xffffffff;  /* Ƶļβ,Ϊλ,Իļβͷ */
		i = CH374FileLocate( );  /* »صԭļβ,дݽβͷ,ͷһݸڻ, */
		mStopIfError( i );
	}
	else if ( total >= sizeof( my_buffer ) - CH374vSectorSize ) {  /* еݿҪ,ӦȽеԭдU */
		mCmdParam.WriteX.mSectorCount = total / CH374vSectorSize;  /* еֽתΪ(CH374vSectorSize),ͷȲ */
		mCmdParam.WriteX.mDataBuffer = my_buffer;  /*  */
		i = CH374FileWriteX( );  /* Ϊλļд,д뻺е,ͷ */
		mStopIfError( i );
		memcpy( my_buffer, & my_buffer[ total & ~ ( CH374vSectorSize - 1 ) ], total & ( CH374vSectorSize - 1 ) );  /* ղδдU̵ͷݸƵͷ */
		total &= CH374vSectorSize - 1;  /* ֻʣ¸ղδдU̵ͷ */
/*		mCmdParam.WriteX.mSectorCount = 0;  ָд0,ˢļĳ,ֹûüرļ֮ǰϵļȲ
		CH374FileWriteX( );  Ϊλļд,Ϊ0д,ֻڸļĳ,׶дݺ,ְ취ļ */
	}
}

main( ) {
	UINT8	i, month, date, hour;
	UINT16	year, adc;
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	CH374DelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

#if DISK_BASE_BUF_LEN == 0
	pDISK_BASE_BUF = &my_buffer[0];  /* .HļжCH374רû,ûָָӦóĻںԽԼRAM */
#endif

	i = CH374LibInit( );  /* ʼCH374CH374оƬ,ɹ0 */
	mStopIfError( i );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk\n" );
		while ( 1 ) {  /* ѯCH374жϲж״̬,ȴU̲ */
			CH374DelaymS( 50 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) == ERR_SUCCESS ) break;  /* 豸򷵻سɹ,CH374DiskConnectͬʱȫֱCH374DiskStatus */
		}
		LED_OUT_ACT( );  /* LED */
		CH374DelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

		for ( i = 0; i < 5; i ++ ) {  /* ȴʱ,5*50mS */
			CH374DelaymS( 50 );
			printf( "Ready ?\n" );
			if ( CH374DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
			if ( CH374DiskStatus < DISK_CONNECT ) break;  /* ⵽Ͽ,¼Ⲣʱ */
			if ( CH374DiskStatus >= DISK_MOUNTED ) break;  /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
		}
		if ( CH374DiskStatus < DISK_CONNECT ) {  /* ⵽Ͽ,¼Ⲣʱ */
			printf( "Device gone\n" );
			continue;  /* µȴ */
		}
		if ( CH374DiskStatus < DISK_MOUNTED ) {  /* δ֪USB豸,USB̡ӡ */
			printf( "Unknown device\n" );
			continue;  /* µȴ */
		}

#if DISK_BASE_BUF_LEN
		if ( DISK_BASE_BUF_LEN < CH374vSectorSize ) {  /* ݻǷ㹻,CH374vSectorSizeU̵ʵС */
			printf( "Too large sector size\n" );
			continue;
		}
#endif

/* ѯ */
		printf( "DiskSize\n" );
		i = CH374DiskSize( );  
		mStopIfError( i );
		printf( "TotalSize = %u MB \n", (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec * ( CH374vSectorSize / 512 ) >> 11 ) );  /* ʾΪMBΪλ */
		LED_RUN_ACT( );  /* ʼU */

/* MY_ADC.TXTļѾݵβ,½ļ */
		printf( "Open\n" );
		strcpy( mCmdParam.Open.mPathName, "/MY_ADC.TXT" );  /* ļ,ļڸĿ¼ */
		i = CH374FileOpen( );  /* ļ */
		if ( i == ERR_SUCCESS ) {  /* ļڲѾ,ƶļָ뵽βԱ */
			printf( "File size = %ld\n", CH374vFileSize );  /* ڳɹļ,ȫֱCH374vFileSizeļǰ */
			printf( "Locate tail\n" );
			mCmdParam.Locate.mSectorOffset = 0xffffffff;  /* Ƶļβ,CH374ӳڲǽļȰCH374vSectorSizeȡ */
			i = CH374FileLocate( );  /* ΪλƵļβ,ļβвһͷ򱻺,ôͷݽܱдݸ */
			mStopIfError( i );
			total = CH374vFileSize & ( CH374vSectorSize - 1 );  /* ϴαļʱβͷ,ôȡͷֽ,ȵ */
			printf( "Read last tail = %d Bytes\n", total );
			CH374vFileSize += CH374vSectorSize - 1;  /* Ϊؽļһ1,Աһеͷ */
			mCmdParam.ReadX.mSectorCount = 1;  /* ȡļβͷ,Ϊļ,ôļȰCH374vSectorSizeȡ,βͷ޷ */
			mCmdParam.ReadX.mDataBuffer = my_buffer;  /* ݷŵ */
			i = CH374FileReadX();  /* ļȡβͷ,ԭβûͷ,ôʲôҲ,ʱmCmdParam.ReadX.mSectorCountΪʵʶ */
			mStopIfError( i );
			CH374vFileSize -= CH374vSectorSize - 1;  /* ָļ */
			mCmdParam.Locate.mSectorOffset = 0xffffffff;  /* Ƶļβ,Ϊλ,Իļβͷ */
			i = CH374FileLocate( );  /* »صԭļβ,дݽԭβͷ,ԭͷݸղѾڴ, */
			mStopIfError( i );
		}
		else if ( i == ERR_MISS_FILE ) {  /* ûҵļ,½ļ */
			LED_WR_ACT( );  /* д */
			printf( "Create\n" );
//			strcpy( mCmdParam.Create.mPathName, "/MY_ADC.TXT" );  /* ļ,ļڸĿ¼,ղѾṩCH374FileOpen */
			i = CH374FileCreate( );  /* ½ļ,ļѾɾ½ */
			mStopIfError( i );
			total = 0;  /* ǰûͷ */
		}
		else mStopIfError( i );  /* ļʱ */
		LED_WR_ACT( );  /* д */
		printf( "Write begin\n" );
		total += sprintf( & my_buffer[ total ], "ڱ֮ǰ,ļݵĳ %ld ֽ\xd\xa", CH374vFileSize );  /* ӵβ,ۼƻڵݳ */
		mFlushBufferToDisk( 0 );  /* Զˢ»,黺Ƿ,д */
		printf( "Write ADC data\n" );
		TR0=1;  /* öʱ0ļֵADC */
		for ( month = 1; month != 12; month ++ ) {  /* Ϊ԰ûʵʱʱоƬ,ѭʽģ· */
			for ( date = 1; date != 30; date ++ ) {  /* Ϊ԰ûʵʱʱоƬ,ѭʽģ */
				year = 2004;  /* ٶΪ2004 */
				hour = TL1 & 0x1F;  /* Ϊ԰ûʵʱʱоƬ,öʱ1ļʾ */
/*				adc = get_adc_data( ); */
				adc = ( (UINT16)TH0 << 8 ) | TL0;  /* Ϊ԰ûADC,öʱ0ļADCʾ */
				total += sprintf( & my_buffer[ total ], "Year=%04d, Month=%02d, Date=%02d, Hour=%02d, ADC_data=%u\xd\xa", year, (UINT16)month, (UINT16)date, (UINT16)hour, adc );  /* ݸʽΪһַ */
				if ( month == 6 && ( date & 0x0F ) == 0 ) mFlushBufferToDisk( 1 );  /* ǿˢ»,ǿˢ»,ͻȻϵԼݶʧ */
				else mFlushBufferToDisk( 0 );  /* Զˢ»,黺Ƿ,д */
				printf( "Current total is %d\n", total );  /* ڼؼ */
			}
		}
		printf( "Write end\n" );
		total += sprintf( & my_buffer[ total ], " ********************************* " );  /* ӵβ,ۼƻڵݳ */
		total += sprintf( & my_buffer[ total ], "εADCݵ˽,򼴽˳\xd\xa" );  /* ӵβ,ۼƻڵݳ */
		mFlushBufferToDisk( 1 );  /* ǿˢ»,ΪϵͳҪ˳,Աǿˢ */
		printf( "Close\n" );
		mCmdParam.Close.mUpdateLen = 0;  /* Ϊǿˢ»ʱѾļ,ﲻҪԶļ */
		i = CH374FileClose( );  /* رļ */
		mStopIfError( i );
		LED_WR_INACT( );
		LED_RUN_INACT( );
		printf( "Take out\n" );
		while ( 1 ) {  /* ֧USB-HUB */
			CH374DelaymS( 10 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) != ERR_SUCCESS ) break;  /* ѯʽ: ǷӲ´״̬,سɹ˵ */
		}
		LED_OUT_INACT( );  /* LED */
		CH374DelaymS( 200 );
	}
}
