/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH374 **
**  TC2.0@PC, ADS_C_1.2@ARM           **
****************************************
*/
/* CH374 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* ARMƬCԵUļдʾ */
/* óUе/C51/CH374HFT.Cļеǰ600ַʾ,
   ҲԭļCH374HFT.C, ôóʾC51Ŀ¼CH374ͷļ,
   ҲC51Ŀ¼, ôóʾĿ¼µļ,
   󽫳ROMеһַдд½ļ"NEWFILE.TXT"
*/
/* CH374INT#Ųòѯʽ, ݸƷʽΪ"ڲ", Philips LPC2114Ƭ, 0Ϣ,9600bps */
/* ENDIAN = "little" */

/* ֽΪλдUļ,дٶȽģʽ,ֽģʽдļҪļݻFILE_DATA_BUF,
   ֻܹҪ600ֽڵRAM,ڵƬӲԴޡСҶдٶҪ󲻸ߵϵͳ */

/* ARMCC -c -asm -o CH374HF9.O CH374HF9.C -ISRC\ */
/* ARMLINK -o CH374HFT.AXF -scatter SRC\LPC2114.SCF -entry 0 CH374HFT.O SRC\STARTUP.O SRC\HEAP.O SRC\STACK.O CH374HF9.LIB */
/* FROMELF -bin -o CH374HFT.BIN CH374HFT.AXF */

#include "TARGET.C"						/* Ŀרóʼ */

#include <stdio.h>
#include <string.h>

/* ¶ϸ˵뿴CH374HF9.Hļ */
#define LIB_CFG_INT_EN			0		/* CH374INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */

//#define CH374_INT_WIRE			( IO0PIN & 0x08 )	/* P0.3, CH374жINT#,CH374INT#,ڲѯж״̬ */
/* δCH374ж,ôӦȥ,ԶʹüĴѯʽ */

//#define DISK_BASE_BUF_LEN		2048	/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
/* ҪôݻԽԼRAM,ôɽDISK_BASE_BUF_LENΪ0Խֹ.Hļж建,ӦóڵCH375Init֮ǰõĻʼַpDISK_BASE_BUF */

#define NO_DEFAULT_CH374_F_ENUM		1		/* δCH374FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH374_F_QUERY	1		/* δCH374FileQueryʽֹԽԼ */
#define NO_DEFAULT_CH374_RESET		1		/* δCH374ResetʽֹԽԼ */

#include "..\CH374HF9.H"

/* Ӳ׼SPIӿ0CH3744SPIڶдʱ */
/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/* LPC2114Ƭ    CH374оƬ
         P0.3                 SCS#
         P0.4                 SCK
         P0.5                 SDO
         P0.6                 SDI     */

void CH374_PORT_INIT( )  /* гʼ */
{
	IO0SET |= 0x00000008;  /* ֹSPIƬѡ,SCS#ĬΪߵƽ */
	IO0DIR |= 0x00000008;  /* SCS#Ϊ */
	PINSEL0 = PINSEL0 & 0xFFFF00FF | 0x00005500;  // I/OӵSPI0
	S0PCCR = 0x08;
/* ӲSPIӿ,ôʹmode3(CPOL=1&CPHA=1)mode0(CPOL=0&CPHA=0),CH374ʱز,½,λǸλǰ */
	S0PCR = 0x38;  /* SPIģʽ3, LSBF=0(MSB first), CPOL=1, CPHA=1, CH374Ҳ֧SPIģʽ0 */
}

static	UINT8	Spi374Exchange( UINT8 d )  /* ӲSPI8λ */
{  /* Ϊٶ,ԽӳɺԼӳò */
	S0PDR = d;  /* ȽдSPIݼĴ,ȻѯSPI״̬ĴԵȴSPIֽڴ */
	while ( ( S0PSR & 0x80 ) == 0 );  /* ѯSPI״̬ĴԵȴSPIֽڴ */
	return( S0PDR );  /* ȲѯSPI״̬ĴԵȴSPIֽڴ,ȻSPIݼĴ */
}

#define	Spi374OutByte( d )		Spi374Exchange( d )		/* SPI8λ */
#define	Spi374InByte( )			Spi374Exchange( 0xFF )	/* SPI8λ */

static	void	Spi374Start( UINT8 addr, UINT8 cmd )  /* SPIʼ */
{
	IO0CLR = 0x00000008;  /* SPIƬѡЧ */
	Spi374OutByte( addr );
	Spi374OutByte( cmd );
}

#define	Spi374Stop( )	{ IO0SET |= 0x00000008; }  /* SPI */
//static	void	Spi374Stop( void )  /* SPI */
//{
//	IO0SET |= 0x00000008;	/* SPIƬѡЧ */
//}

/*#include "PARA.C"*/	/* ʱ */
#include "SPI.C"    /* SPIʱ */

/* P0.2һLEDڼʾĽ,͵ƽLED */
#define LED_OUT_INIT( )		{ IO0DIR |= 0x04; }	/* P0.2 ߵƽΪ */
#define LED_OUT_ACT( )		{ IO0CLR |= 0x04; }	/* P0.2 ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ IO0SET |= 0x04; }	/* P0.2 ͵ƽLEDʾ */

/* ״̬,ʾ벢ͣ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
/* ,Ӧ÷ԼCH374DiskStatus״̬,CH374DiskConnectѯǰUǷ,UѶϿôµȴU̲ٲ,
   Ĵ:
   1һCH374DiskReady,ɹ,Open,Read/Write,CH374DiskReadyлԶCH374DiskConnect
   2CH374DiskReadyɹ,ôǿнCH374DiskStatusΪDISK_CONNECT״̬,Ȼͷʼ(ȴUCH374DiskConnectCH374DiskReady) */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		CH374DelaymS( 100 );
		LED_OUT_INACT( );
		CH374DelaymS( 100 );
	}
}

/* Ϊprintfgetkeyʼ */
void	mInitSTDIO( )
{
	UINT32	x;
	PINSEL0 = PINSEL0 & 0xFFFFFFF0 | 0x00000005;  // I/OӵUART0
	U0LCR = 0x80;                    // DLABλ1
	x = (Fpclk>>4)/9600;             // 9600bps
	U0DLM = x>>8;
	U0DLL = x&0xff;
	U0LCR = 0x03;                    // 8λλ,1λֹͣλ,żУ
	U0FCR = 0x01;
}

/* ͨϢ */
int		fputc( int c, FILE *f )
{
	U0THR = c;                            // 
	while( ( U0LSR & 0x20 ) == 0 );       // ȴݷ
	return( c );
}

int	main( ) {
	UINT8	i, c;
	UINT16	TotalCount;
	UINT8	*pCodeStr;
	CH374_PORT_INIT( );
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	CH374DelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

#if DISK_BASE_BUF_LEN == 0
	pDISK_BASE_BUF = &my_buffer[0];  /* .HļжCH374רû,ûָָӦóĻںԽԼRAM */
#endif

	i = CH374LibInit( );  /* ʼCH374CH374оƬ,ɹ0 */
	mStopIfError( i );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk\n" );
		while ( 1 ) {  /* ֧USB-HUB,ӵĴοEXAM1EXAM13 */
			CH374DelaymS( 10 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) == ERR_SUCCESS ) break;  /* ѯʽ: ǷӲ´״̬,سɹ˵ */
		}
		LED_OUT_ACT( );  /* LED */
		CH374DelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* UǷ׼,ЩU̲Ҫһ,ĳЩU̱Ҫִһܹ */
		for ( i = 0; i < 5; i ++ ) {  /* еUǷδ׼,Ա */
			CH374DelaymS( 100 );
			printf( "Ready ?\n" );
			if ( CH374DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
		}
		if ( CH374DiskStatus <= DISK_CONNECT ) continue;  /* ֧USB-HUB */

#if DISK_BASE_BUF_LEN
		if ( DISK_BASE_BUF_LEN < CH374vSectorSize ) {  /* ݻǷ㹻,CH374vSectorSizeU̵ʵС */
			printf( "Too large sector size\n" );
			continue;
		}
#endif

/* ѯ */
/*		printf( "DiskSize\n" );
		i = CH374DiskSize( );  
		mStopIfError( i );
		printf( "TotalSize = %u MB \n", (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec * ( CH374vSectorSize / 512 ) >> 11 ) );  ʾΪMBΪλ
*/

/* ȡԭļ */
		printf( "Open\n" );
		strcpy( (char *)mCmdParam.Open.mPathName, "/C51/CH374HFT.C" );  /* ļ,ļC51Ŀ¼ */
		i = CH374FileOpen( );  /* ļ */
		if ( i == ERR_MISS_DIR || i == ERR_MISS_FILE ) {  /* ûҵļ */
/* гļ */
			if ( i == ERR_MISS_DIR ) pCodeStr = (PUINT8)"/*";  /* C51Ŀ¼гĿ¼µļ */
			else pCodeStr = (PUINT8)"/C51/CH374*";  /* CH374HFT.Cļг\C51Ŀ¼µCH374ͷļ */
			printf( "List file %s\n", pCodeStr );
			for ( c = 0; c < 254; c ++ ) {  /* ǰ254ļ,Ҫ255ļοEXAM1EXAM0 */
				strcpy( (char *)mCmdParam.Open.mPathName, (char *)pCodeStr );  /* ļ,*Ϊͨ,ļĿ¼ */
/* һöٷǣ˴cΪ0xFFȻöŴCH374vFileSizeУӶ254ļ02147483647 */
				i = strlen( (char *)mCmdParam.Open.mPathName );
				mCmdParam.Open.mPathName[ i ] = c;  /* ַȽ滻Ϊ,0254 */
				i = CH374FileOpen( );  /* ļ,ļкͨ*,Ϊļ */
				if ( i == ERR_MISS_FILE ) break;  /* Ҳƥļ,Ѿûƥļ */
				if ( i == ERR_FOUND_NAME ) {  /* ͨƥļ,ļ· */
					printf( "  match file %03d#: %s\n", (unsigned int)c, mCmdParam.Open.mPathName );  /* ʾźƥļĿ¼ */
					continue;  /* һƥļ,´ʱŻ1 */
				}
				else {  /*  */
					mStopIfError( i );
					break;
				}
			}
		}
		else {  /* ҵļ߳ */
			mStopIfError( i );
			TotalCount = 600;  /* ׼ȡܳ */
			printf( "ļжǰ%dַ:\n",TotalCount );
			while ( TotalCount ) {  /* ļȽϴ,һζ,ٵCH374ByteReadȡ,ļָԶƶ */
				if ( TotalCount > MAX_BYTE_IO ) c = MAX_BYTE_IO;  /* ʣݽ϶,ƵζдĳȲܳ sizeof( mCmdParam.ByteRead.mByteBuffer ) */
				else c = TotalCount;  /* ʣֽ */
				mCmdParam.ByteRead.mByteCount = c;  /* ʮֽ */
				i = CH374ByteRead( );  /* ֽΪλȡݿ,ζдĳȲܳMAX_BYTE_IO,ڶεʱŸղŵ */
				mStopIfError( i );
				TotalCount -= mCmdParam.ByteRead.mByteCount;  /* ,ȥǰʵѾַ */
				for ( i=0; i!=mCmdParam.ByteRead.mByteCount; i++ ) printf( "%c", mCmdParam.ByteRead.mByteBuffer[i] );  /* ʾַ */
				if ( mCmdParam.ByteRead.mByteCount < c ) {  /* ʵʶַҪַ,˵ѾļĽβ */
					printf( "\n" );
					printf( "ļѾ\n" );
					break;
				}
			}
/*	    ϣָλÿʼд,ƶļָ
		mCmdParam.ByteLocate.mByteOffset = 608;  ļǰ608ֽڿʼд
		CH374ByteLocate( );
		mCmdParam.ByteRead.mByteCount = 5;  ȡ5ֽ
		CH374ByteRead( );   ֱӶȡļĵ608ֽڵ612ֽ,ǰ608ֽڱ

	    ϣӵԭļβ,ƶļָ
		CH374FileOpen( );
		mCmdParam.ByteLocate.mByteOffset = 0xffffffff;  Ƶļβ
		CH374ByteLocate( );
		mCmdParam.ByteWrite.mByteCount = 13;  д13ֽڵ
		CH374ByteWrite( );   ԭļĺ,¼ӵ13ֽڽԭļβ
		mCmdParam.ByteWrite.mByteCount = 2;  д2ֽڵ
		CH374ByteWrite( );   ԭļĺ
		mCmdParam.ByteWrite.mByteCount = 0;  д0ֽڵ,ʵϸò֪ͨļ
		CH374ByteWrite( );   д0ֽڵ,Զļĳ,ļ15,,ôִCH374FileCloseʱҲԶļ
*/
			printf( "Close\n" );
			i = CH374FileClose( );  /* رļ */
			mStopIfError( i );
		}

#ifdef EN_DISK_WRITE  /* ӳ֧д */
/* ļ */
		printf( "Create\n" );
		strcpy( (char *)mCmdParam.Create.mPathName, "/NEWFILE.TXT" );  /* ļ,ڸĿ¼,ļ */
		i = CH374FileCreate( );  /* ½ļ,ļѾɾ½ */
		mStopIfError( i );
		printf( "Write\n" );
		pCodeStr = (PUINT8)"Note: \xd\xaֽΪλUļд,ƬֻҪ600ֽڵRAM\xd\xa";
		while( 1 ) {  /* ֶдļ */
			for ( i=0; i<MAX_BYTE_IO; i++ ) {
				c = *pCodeStr;
				mCmdParam.ByteWrite.mByteBuffer[i] = c;
				if ( c == 0 ) break;  /* Դַ */
				pCodeStr++;
			}
			if ( i == 0 ) break;  /* Դַ,дļ */
			mCmdParam.ByteWrite.mByteCount = i;  /* дݵַ,ζдĳȲܳMAX_BYTE_IO,ڶεʱŸղŵд */
			i = CH374ByteWrite( );  /* ļд */
			mStopIfError( i );
		}
/*		printf( "Modify\n" );
		mCmdParam.Modify.mFileAttr = 0xff;   : µļ,Ϊ0FFH޸
		mCmdParam.Modify.mFileTime = 0xffff;   : µļʱ,Ϊ0FFFFH޸,ʹ½ļĬʱ
		mCmdParam.Modify.mFileDate = MAKE_FILE_DATE( 2004, 5, 18 );  : µļ: 2004.05.18
		mCmdParam.Modify.mFileSize = 0xffffffff;   : µļ,ֽΪλдļӦɳرļʱԶ³,Դ˴޸
		i = CH374FileModify( );   ޸ĵǰļϢ,޸
		mStopIfError( i );
*/
		printf( "Close\n" );
		mCmdParam.Close.mUpdateLen = 1;  /* Զļ,ֽΪλдļ,óرļԱԶļ */
		i = CH374FileClose( );
		mStopIfError( i );

/* ɾĳļ */
/*		printf( "Erase\n" );
		strcpy( (char *)mCmdParam.Create.mPathName, "/OLD" );  ɾļ,ڸĿ¼
		i = CH374FileErase( );  ɾļر
		if ( i != ERR_SUCCESS ) printf( "Error: %02X\n", (UINT16)i );  ʾ
*/

/* ѯϢ */
/*		printf( "Disk\n" );
		i = CH374DiskQuery( );
		mStopIfError( i );
		printf( "Fat=%d, Total=%ld, Free=%ld\n", (UINT16)mCmdParam.Query.mDiskFat, mCmdParam.Query.mTotalSector, mCmdParam.Query.mFreeSector );
*/
#endif
		printf( "Take out\n" );
		while ( 1 ) {  /* ֧USB-HUB */
			CH374DelaymS( 10 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) != ERR_SUCCESS ) break;  /* ѯʽ: ǷӲ´״̬,سɹ˵ */
		}
		LED_OUT_INACT( );  /* LED */
		CH374DelaymS( 200 );
	}
}
