/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH374 **
**  TC2.0@PC, IAR_C/EC++EW23_226C@AVR **
****************************************
*/
/* CH374 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* AVRƬCԵUļдʾ */
/* óUе/C51/CH374HFT.Cļеǰ600ַʾ,
   ҲԭļCH374HFT.C, ôóʾC51Ŀ¼CH374ͷļ,
   ҲC51Ŀ¼, ôóʾĿ¼µļ,
   󽫳ROMеһַдд½ļ"NEWFILE.TXT"
*/
/* CH374INT#Ųòѯʽ, ݸƷʽΪ"ڲ", ATmega128Ƭ, 0Ϣ,9600bps */
/* ֽΪλдUļ,дٶȽģʽ,ֽģʽдļҪļݻFILE_DATA_BUF,
   ֻܹҪ600ֽڵRAM,ڵƬӲԴޡСҶдٶҪ󲻸ߵϵͳ */

/* ICCAVR CH374HFT.C -l CH374HFT.LST -o CH374HFT.R90 -v3 -ms -y --enhanced_core --initializers_in_flash */
/* XLINK CH374HFT.R90 -o CH374HFT.HEX -Fintel-extended ..\AVR\lib\cl3s-ec.r90 CH374HFJ.R90 -f ..\AVR\config\lnkm128s.xcl */

#define	ENABLE_BIT_DEFINITIONS	1
#include <iom128.h>
#include <string.h>
#include <stdio.h>

/* ¶ϸ˵뿴CH374HF9.Hļ */
#define LIB_CFG_INT_EN			0		/* CH374INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */

#define CH374_INT_WIRE			( PINB & 0x10 )	/* PINB.4, CH374жINT#,CH374INT#,ڲѯж״̬ */
/* δCH374ж,ôӦȥ,ԶʹüĴѯʽ */

//#define DISK_BASE_BUF_LEN		2048	/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
/* ҪôݻԽԼRAM,ôɽDISK_BASE_BUF_LENΪ0Խֹ.Hļж建,ӦóڵCH375Init֮ǰõĻʼַpDISK_BASE_BUF */

#define NO_DEFAULT_CH374_F_ENUM		1		/* δCH374FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH374_F_QUERY	1		/* δCH374FileQueryʽֹԽԼ */
#define NO_DEFAULT_CH374_RESET		1		/* δCH374ResetʽֹԽԼ */

#pragma language=extended
#include "..\CH374HFJ.H"
#pragma language=default

/* ЩAVRƬṩϵͳ,ôֱӽCH374ϵͳ,8λI/Oʽжд */
/* ȻAtmega128ṩϵͳ,ٶϵͳ,I/OģCH374Ĳڶдʱ */
/* еӲӷʽ(ʵӦõ·Բ޸3ڶдӳ) */
/*    Ƭ     CH374оƬ
       PINB.4                INT#
       PORTB.3               A0
       PORTB.2               CS#
       PORTB.1               WR#
       PORTB.0               RD#
      PORTA(8λ˿)        D7-D0       */

void CH374_PORT_INIT( )  /* ʹͨI/OģⲢڶдʱ,Խгʼ */
{
	DDRA = 0x00;  /* 8λΪ */
	PORTB = 0x07;  /* CS,WR,RDĬΪߵƽ */
	DDRB = 0x0F;  /* CS,WR,RD,A0Ϊ,INT#Ϊ */
}

void Write374Index( UINT8 mCmd )		/* ˿дַ */
{
/*	*(volatile unsigned char *)CH374_IDX_PORT_ADDR = mCmd;  ֱͨӶдCH374ͨI/Oģ */
	PORTB |= 0x08;  /* A0=1 */
	PORTA = mCmd;  /* CH374Ĳ */
	DDRA = 0xFF;  /* D0-D7 */
	PORTB &= 0xF9;  /* Чдź, дCH374оƬ˿, A0=1; CS=0; WR=0; RD=1; */
	DDRA = 0xFF;  /* ò,ʱ,CH374Ҫдȴ100nS */
	PORTB |= 0x07;  /* ЧĿź, ɲCH374оƬ, A0=1; CS=1; WR=1; RD=1; */
	DDRA = 0x00;  /* ֹ */
	PORTB &= 0xF7;  /* A0=0; ѡ */
}

void Write374Data( UINT8 mData )		/* ݶ˿д,ַԶ1 */
{
/*	*(volatile unsigned char *)CH374_DAT_PORT_ADDR = mData;  ֱͨӶдCH374ͨI/Oģ */
	PORTA = mData;  /* CH374Ĳ */
	DDRA = 0xFF;  /* D0-D7 */
	PORTB &= 0xF1;  /* Чдź, дCH374оƬݶ˿, A0=0; CS=0; WR=0; RD=1; */
	DDRA = 0xFF;  /* ò,ʱ,CH374Ҫдȴ100nS */
	PORTB |= 0x07;  /* ЧĿź, ɲCH374оƬ, A0=0; CS=1; WR=1; RD=1; */
	DDRA = 0x00;  /* ֹ */
}

UINT8 Read374Data( void )			/* ݶ˿ڶ,ַԶ1 */
{
	UINT8	mData;
/*	mData = *(volatile unsigned char *)CH374_DAT_PORT_ADDR;  ֱͨӶдCH374ͨI/Oģ */
	DDRA = 0x00;  /*  */
	PORTB &= 0xF2;  /* Чź, CH374оƬݶ˿, A0=0; CS=0; WR=1; RD=0; */
	DDRA = 0x00;  /* ò,ʱ,CH374Ҫдȴ100nS */
	mData = PINA;  /* CH374ĲPA */
	PORTB |= 0x07;  /* ЧĿź, ɲCH374оƬ, A0=0; CS=1; WR=1; RD=1; */
	return( mData );
}

#include "PARA.C"	/* ʱ */
/*#include "SPI.C"*/    /* SPIʱ */

/* PB.7һLEDڼʾĽ,͵ƽLED */
#define LED_OUT_INIT( )		{ PORTB |= 0x80; DDRB |= 0x80; }	/* PORTB.7 ߵƽΪ */
#define LED_OUT_ACT( )		{ PORTB &= 0x7F; }	/* PORTB.7 ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ PORTB |= 0x80; }	/* PORTB.7 ͵ƽLEDʾ */

/* ״̬,ʾ벢ͣ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
/* ,Ӧ÷ԼCH374DiskStatus״̬,CH374DiskConnectѯǰUǷ,UѶϿôµȴU̲ٲ,
   Ĵ:
   1һCH374DiskReady,ɹ,Open,Read/Write,CH374DiskReadyлԶCH374DiskConnect
   2CH374DiskReadyɹ,ôǿнCH374DiskStatusΪDISK_CONNECT״̬,Ȼͷʼ(ȴUCH374DiskConnectCH374DiskReady) */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		CH374DelaymS( 100 );
		LED_OUT_INACT( );
		CH374DelaymS( 100 );
	}
}

/* Ϊprintfgetkeyʼ */
void	mInitSTDIO( )
{
	UBRR0H = 0;
	UBRR0L = 103;  /* 9600bps@16MHz */
	UCSR0B = 0x18; /* BIT(RXEN) | BIT(TXEN); */
	UCSR0C = 0x06; /* BIT(UCSZ1) | BIT(UCSZ0); */
}

/* ͨϢ */
int		putchar( int c )
{
	while ( !( UCSR0A & (1<<UDRE0)) );  /* Wait for empty transmit buffer */
	UDR0 = c;  /* Put data into buffer, sends the data */
	return( c );
}

int	main( ) {
	UINT8	i, c;
	UINT16	TotalCount;
	UINT8	*pCodeStr;
	CH374_PORT_INIT( );
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	CH374DelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

#if DISK_BASE_BUF_LEN == 0
	pDISK_BASE_BUF = &my_buffer[0];  /* .HļжCH374רû,ûָָӦóĻںԽԼRAM */
#endif

	i = CH374LibInit( );  /* ʼCH374CH374оƬ,ɹ0 */
	mStopIfError( i );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk\n" );
		while ( 1 ) {  /* ֧USB-HUB,ӵĴοEXAM1EXAM13 */
			CH374DelaymS( 10 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) == ERR_SUCCESS ) break;  /* ѯʽ: ǷӲ´״̬,سɹ˵ */
		}
		LED_OUT_ACT( );  /* LED */
		CH374DelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* UǷ׼,ЩU̲Ҫһ,ĳЩU̱Ҫִһܹ */
		for ( i = 0; i < 5; i ++ ) {  /* еUǷδ׼,Ա */
			CH374DelaymS( 100 );
			printf( "Ready ?\n" );
			if ( CH374DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
		}
		if ( CH374DiskStatus <= DISK_CONNECT ) continue;  /* ֧USB-HUB */

/* ѯ */
/*		printf( "DiskSize\n" );
		i = CH374DiskSize( );  
		mStopIfError( i );
		printf( "TotalSize = %u MB \n", (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec * ( CH374vSectorSize / 512 ) >> 11 ) );  ʾΪMBΪλ
*/

/* ȡԭļ */
		printf( "Open\n" );
		strcpy( (char *)mCmdParam.Open.mPathName, "/C51/CH374HFT.C" );  /* ļ,ļC51Ŀ¼ */
		i = CH374FileOpen( );  /* ļ */
		if ( i == ERR_MISS_DIR || i == ERR_MISS_FILE ) {  /* ûҵļ */
/* гļ */
			if ( i == ERR_MISS_DIR ) pCodeStr = (PUINT8)"/*";  /* C51Ŀ¼гĿ¼µļ */
			else pCodeStr = (PUINT8)"/C51/CH374*";  /* CH374HFT.Cļг\C51Ŀ¼µCH374ͷļ */
			printf( "List file %s\n", pCodeStr );
			for ( c = 0; c < 254; c ++ ) {  /* ǰ254ļ,Ҫ255ļοEXAM1EXAM0 */
				strcpy( (char *)mCmdParam.Open.mPathName, (char *)pCodeStr );  /* ļ,*Ϊͨ,ļĿ¼ */
/* һöٷǣ˴cΪ0xFFȻöŴCH374vFileSizeУӶ254ļ02147483647 */
				i = strlen( (char *)mCmdParam.Open.mPathName );
				mCmdParam.Open.mPathName[ i ] = c;  /* ַȽ滻Ϊ,0254 */
				i = CH374FileOpen( );  /* ļ,ļкͨ*,Ϊļ */
				if ( i == ERR_MISS_FILE ) break;  /* Ҳƥļ,Ѿûƥļ */
				if ( i == ERR_FOUND_NAME ) {  /* ͨƥļ,ļ· */
					printf( "  match file %03d#: %s\n", (unsigned int)c, mCmdParam.Open.mPathName );  /* ʾźƥļĿ¼ */
					continue;  /* һƥļ,´ʱŻ1 */
				}
				else {  /*  */
					mStopIfError( i );
					break;
				}
			}
		}
		else {  /* ҵļ߳ */
			mStopIfError( i );
			TotalCount = 600;  /* ׼ȡܳ */
			printf( "ļжǰ%dַ:\n",TotalCount );
			while ( TotalCount ) {  /* ļȽϴ,һζ,ٵCH374ByteReadȡ,ļָԶƶ */
				if ( TotalCount > MAX_BYTE_IO ) c = MAX_BYTE_IO;  /* ʣݽ϶,ƵζдĳȲܳ sizeof( mCmdParam.ByteRead.mByteBuffer ) */
				else c = TotalCount;  /* ʣֽ */
				mCmdParam.ByteRead.mByteCount = c;  /* ʮֽ */
				i = CH374ByteRead( );  /* ֽΪλȡݿ,ζдĳȲܳMAX_BYTE_IO,ڶεʱŸղŵ */
				mStopIfError( i );
				TotalCount -= mCmdParam.ByteRead.mByteCount;  /* ,ȥǰʵѾַ */
				for ( i=0; i!=mCmdParam.ByteRead.mByteCount; i++ ) printf( "%c", mCmdParam.ByteRead.mByteBuffer[i] );  /* ʾַ */
				if ( mCmdParam.ByteRead.mByteCount < c ) {  /* ʵʶַҪַ,˵ѾļĽβ */
					printf( "\n" );
					printf( "ļѾ\n" );
					break;
				}
			}
/*	    ϣָλÿʼд,ƶļָ
		mCmdParam.ByteLocate.mByteOffset = 608;  ļǰ608ֽڿʼд
		CH374ByteLocate( );
		mCmdParam.ByteRead.mByteCount = 5;  ȡ5ֽ
		CH374ByteRead( );   ֱӶȡļĵ608ֽڵ612ֽ,ǰ608ֽڱ

	    ϣӵԭļβ,ƶļָ
		CH374FileOpen( );
		mCmdParam.ByteLocate.mByteOffset = 0xffffffff;  Ƶļβ
		CH374ByteLocate( );
		mCmdParam.ByteWrite.mByteCount = 13;  д13ֽڵ
		CH374ByteWrite( );   ԭļĺ,¼ӵ13ֽڽԭļβ
		mCmdParam.ByteWrite.mByteCount = 2;  д2ֽڵ
		CH374ByteWrite( );   ԭļĺ
		mCmdParam.ByteWrite.mByteCount = 0;  д0ֽڵ,ʵϸò֪ͨļ
		CH374ByteWrite( );   д0ֽڵ,Զļĳ,ļ15,,ôִCH374FileCloseʱҲԶļ
*/
			printf( "Close\n" );
			i = CH374FileClose( );  /* رļ */
			mStopIfError( i );
		}

#ifdef EN_DISK_WRITE  /* ӳ֧д */
/* ļ */
		printf( "Create\n" );
		strcpy( (char *)mCmdParam.Create.mPathName, "/NEWFILE.TXT" );  /* ļ,ڸĿ¼,ļ */
		i = CH374FileCreate( );  /* ½ļ,ļѾɾ½ */
		mStopIfError( i );
		printf( "Write\n" );
		pCodeStr = (PUINT8)"Note: \xd\xaֽΪλUļд,ƬֻҪ600ֽڵRAM\xd\xa";
		while( 1 ) {  /* ֶдļ */
			for ( i=0; i<MAX_BYTE_IO; i++ ) {
				c = *pCodeStr;
				mCmdParam.ByteWrite.mByteBuffer[i] = c;
				if ( c == 0 ) break;  /* Դַ */
				pCodeStr++;
			}
			if ( i == 0 ) break;  /* Դַ,дļ */
			mCmdParam.ByteWrite.mByteCount = i;  /* дݵַ,ζдĳȲܳMAX_BYTE_IO,ڶεʱŸղŵд */
			i = CH374ByteWrite( );  /* ļд */
			mStopIfError( i );
		}
/*		printf( "Modify\n" );
		mCmdParam.Modify.mFileAttr = 0xff;   : µļ,Ϊ0FFH޸
		mCmdParam.Modify.mFileTime = 0xffff;   : µļʱ,Ϊ0FFFFH޸,ʹ½ļĬʱ
		mCmdParam.Modify.mFileDate = MAKE_FILE_DATE( 2004, 5, 18 );  : µļ: 2004.05.18
		mCmdParam.Modify.mFileSize = 0xffffffff;   : µļ,ֽΪλдļӦɳرļʱԶ³,Դ˴޸
		i = CH374FileModify( );   ޸ĵǰļϢ,޸
		mStopIfError( i );
*/
		printf( "Close\n" );
		mCmdParam.Close.mUpdateLen = 1;  /* Զļ,ֽΪλдļ,óرļԱԶļ */
		i = CH374FileClose( );
		mStopIfError( i );

/* ɾĳļ */
/*		printf( "Erase\n" );
		strcpy( (char *)mCmdParam.Create.mPathName, "/OLD" );  ɾļ,ڸĿ¼
		i = CH374FileErase( );  ɾļر
		if ( i != ERR_SUCCESS ) printf( "Error: %02X\n", (UINT16)i );  ʾ
*/

/* ѯϢ */
/*		printf( "Disk\n" );
		i = CH374DiskQuery( );
		mStopIfError( i );
		printf( "Fat=%d, Total=%ld, Free=%ld\n", (UINT16)mCmdParam.Query.mDiskFat, mCmdParam.Query.mTotalSector, mCmdParam.Query.mFreeSector );
*/
#endif
		printf( "Take out\n" );
		while ( 1 ) {  /* ֧USB-HUB */
			CH374DelaymS( 10 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) != ERR_SUCCESS ) break;  /* ѯʽ: ǷӲ´״̬,سɹ˵ */
		}
		LED_OUT_INACT( );  /* LED */
		CH374DelaymS( 200 );
	}
}
