/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH374 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH374 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* MCS-51ƬCԵUļдʾ, 89C52߸ռĵƬ */
/* ʾUǷд,ʾģ˵İȫƳ,ҲԲοд */
/* CH374INT#Ųòѯʽ, MCS51Ƭ */


/* C51   CH374HFT.C */
/* LX51  CH374HFT.OBJ , CH374HF6.LIB, C51DPTR1.LIB */
/* OHX51 CH374HFT */

#include <reg52.h>
#include <stdio.h>
#include <string.h>

/* ¶ϸ˵뿴CH374HF6.Hļ */
#define	MAX_BYTE_IO				48		/* ֽΪλζдļʱ󳤶,Ĭֵ29,ֵռڴ,ֵС򳬹óȱֶζд */

#define LIB_CFG_INT_EN			0		/* CH374INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */

#define CH374_IDX_PORT_ADDR		0xBDF1	/* CH374˿ڵI/Oַ */
#define CH374_DAT_PORT_ADDR		0xBCF0	/* CH374ݶ˿ڵI/Oַ */
/* 62256ṩ32KBRAMΪ: 0000H-01FFHΪ̶д, 0200H-7FFFHΪļݻ */
#define	DISK_BASE_BUF_ADDR		0x0000	/* ⲿRAMĴݻʼַ,ӸõԪʼĻΪCH374vSectorSize */

#define CH374_INT_WIRE			INT0	/* P3.2, INT0, CH374жINT#,CH374INT#,ڲѯж״̬ */
/* δCH374ж,ôӦȥ,ԶʹüĴѯʽ */

//#define DISK_BASE_BUF_LEN		2048	/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
/* ҪôݻԽԼRAM,ôɽDISK_BASE_BUF_LENΪ0Խֹ.Hļж建,ӦóڵCH375Init֮ǰõĻʼַpDISK_BASE_BUF */

#define NO_DEFAULT_CH374_F_ENUM		1		/* δCH374FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH374_F_QUERY	1		/* δCH374FileQueryʽֹԽԼ */
#define NO_DEFAULT_CH374_RESET		1		/* δCH374ResetʽֹԽԼ */

#include "..\CH374HF6.H"

/* P1.4һLEDڼʾĽ,͵ƽLED,U̲ */
sbit P1_4  = P1^4;
#define LED_OUT_INIT( )		{ P1_4 = 1; }	/* P1.4 ߵƽ */
#define LED_OUT_ACT( )		{ P1_4 = 0; }	/* P1.4 ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ P1_4 = 1; }	/* P1.4 ͵ƽLEDʾ */
sbit P1_5  = P1^5;
/* P1.5һLEDڼʾĽ,͵ƽLED,U̲ʱ */
#define LED_RUN_ACT( )		{ P1_5 = 0; }	/* P1.5 ͵ƽLEDʾ */
#define LED_RUN_INACT( )	{ P1_5 = 1; }	/* P1.5 ͵ƽLEDʾ */
sbit P1_6  = P1^6;
/* P1.6һLEDڼʾĽ,͵ƽLED,Uдʱ */
#define LED_WR_ACT( )		{ P1_6 = 0; }	/* P1.6 ͵ƽLEDʾ */
#define LED_WR_INACT( )		{ P1_6 = 1; }	/* P1.6 ͵ƽLEDʾ */

/* ״̬,ʾ벢ͣ,Ӧ滻ΪʵʵĴʩ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
/* ,Ӧ÷ԼCH374DiskStatus״̬,CH374DiskConnectѯǰUǷ,UѶϿôµȴU̲ٲ,
   Ĵ:
   1һCH374DiskReady,ɹ,Open,Read/Write,CH374DiskReadyлԶCH374DiskConnect
   2CH374DiskReadyɹ,ôǿнCH374DiskStatusΪDISK_CONNECT״̬,Ȼͷʼ(ȴUCH374DiskConnectCH374DiskReady) */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		CH374DelaymS( 200 );
		LED_OUT_INACT( );
		CH374DelaymS( 200 );
	}
}

/* Ϊprintfgetkeyʼ */
void	mInitSTDIO( )
{
	SCON = 0x50;
	PCON = 0x80;
	TMOD = 0x21;
	TH1 = 0xf3;  /* 24MHz, 9600bps */
	TR1 = 1;
	TI = 1;
}

/* UǷд, ERR_SUCCESS˵д,0xFF˵ֻ/д,ֵ˵Ǵ */
/* BulkOnlyЭԲοӴ,޸ǰ˽USB MassStorageSCSI淶 */
UINT8	IsDiskWriteProtect( void )
{
	UINT8	mLength, mStatus, mDevSpecParam;
	mLength = 0x10;
	mBOC.mCBW.mCBW_Flag = 0x80;  /* ䷽Ϊ */
	if ( CH374vRetryCount & (1<<5) ) {  /* ѡ,λ5Ϊ1USB洢豸Ϊ6 */
		mBOC.mCBW.mCBW_DataLen0 = mLength;  /* ݴ䳤 */
		mBOC.mCBW.mCBW_CB_Len = 0x06;  /* 鳤 */
		mBOC.mCBW.mCBW_CB_Buf[0] = 0x1A;  /* ֽ, MODE SENSE(6) */
		mBOC.mCBW.mCBW_CB_Buf[1] = 0x00;
		mBOC.mCBW.mCBW_CB_Buf[2] = 0x3F;
		mBOC.mCBW.mCBW_CB_Buf[3] = 0x00;
		mBOC.mCBW.mCBW_CB_Buf[4] = mLength;
		mBOC.mCBW.mCBW_CB_Buf[5] = 0x00;
	}
	else {
		mBOC.mCBW.mCBW_DataLen0 = mLength;  /* ݴ䳤 */
		mBOC.mCBW.mCBW_CB_Len = 0x0A;  /* 鳤 */
		mBOC.mCBW.mCBW_CB_Buf[0] = 0x5A;  /* ֽ, MODE SENSE(10) */
		mBOC.mCBW.mCBW_CB_Buf[1] = 0x00;
		mBOC.mCBW.mCBW_CB_Buf[2] = 0x3F;
		mBOC.mCBW.mCBW_CB_Buf[3] = 0x00;
		mBOC.mCBW.mCBW_CB_Buf[4] = 0x00;
		mBOC.mCBW.mCBW_CB_Buf[5] = 0x00;
		mBOC.mCBW.mCBW_CB_Buf[6] = 0x00;
		mBOC.mCBW.mCBW_CB_Buf[7] = 0x00;
		mBOC.mCBW.mCBW_CB_Buf[8] = mLength;
		mBOC.mCBW.mCBW_CB_Buf[9] = 0x00;
	}
	mStatus = CH374BulkOnlyCmd( );  /* ִлBulkOnlyЭ,USB洢ִMODE SENSE */
	if ( mStatus == ERR_SUCCESS ) {  /* ɹ */
		mLength -= mBOC.mCBW.mCBW_DataLen0;  /* ɹmBOC.mCBW.mCBW_DataLen0Ϊʣ೤,õʵʴ䳤 */
		if ( mLength > 3 ) {  /* MODE SENSEݵĳЧ */
			if ( CH374vRetryCount & (1<<5) ) mDevSpecParam = *(pDISK_BASE_BUF+2);  /* MODE SENSE(6), device specific parameter */
			else mDevSpecParam = *(pDISK_BASE_BUF+3);  /* MODE SENSE(10), device specific parameter */
			if ( mDevSpecParam & 0x80 ) return( 0xFF );  /* Uд */
			else return( ERR_SUCCESS );  /* Uûд */
		}
		return( ERR_USB_DISK_ERR );
	}
	mLength = 0x12;  /* ҪREQUEST SENSEķ,ô˴ĳȱ0x12 */
	mBOC.mCBW.mCBW_Flag = 0x80;
	mBOC.mCBW.mCBW_DataLen0 = mLength;
	mBOC.mCBW.mCBW_CB_Len = 0x06;  /* 鳤 */
	mBOC.mCBW.mCBW_CB_Buf[0] = SPC_CMD_REQUEST_SENSE;
	mBOC.mCBW.mCBW_CB_Buf[1] = 0;
	mBOC.mCBW.mCBW_CB_Buf[2] = 0;
	mBOC.mCBW.mCBW_CB_Buf[3] = 0;
	mBOC.mCBW.mCBW_CB_Buf[4] = mLength;
	mBOC.mCBW.mCBW_CB_Buf[5] = 0;
	CH374BulkOnlyCmd( );  /* ִлBulkOnlyЭ,USB洢ִREQUEST SENSE */
	return( mStatus );
}

/* ȫƳU, ERR_SUCCESS˵԰ȫƳ,˵ܰȫƳ,ֻǿƳ */
/* ڲU׼ûγUǰ, ֹûγU̶ʧ */
UINT8	SafeRemoveDisk( void )
{
	UINT8	i, s;
	for ( i = 0; i < 10; i ++ ) {  /* еUǷδ׼,Ա */
		CH374DelaymS( 100 );
		if ( CH374DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
	}
	CH374DelaymS( 10 );
	CH374_WRITE_BLOCK_C( 8, (PUINT8C)"\x00\x09\x00\x00\x00\x00\x00" );
	s = CH374CtrlTransfer( );  /* USB豸˵ֵ,ȡ,ᵼºܶU̵LED */
	CH374DelaymS( 10 );
	if ( i < 5 && s == ERR_SUCCESS ) return( ERR_SUCCESS );  /* ɹ */
	else return( 0xFF );
/* ȡSOFᵼ¾U̵LED,CH374ڼ⵽U̲ԶָSOF */
//	CH374_WRITE_REGISTER( REG_USB_SETUP, BIT_SETP_HOST_MODE );  /* USBģʽ,USB߿,ֹͣSOF */
//	CH374DelaymS( 1 );
}

main( ) {
	UINT8	i;
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	CH374DelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

	i = CH374LibInit( );  /* ʼCH374CH374оƬ,ɹ0 */
	mStopIfError( i );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk\n" );

		while ( 1 ) {  /* ֧USB-HUB */
			CH374DelaymS( 50 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) == ERR_SUCCESS ) {  /* ѯʽ: ǷӲ´״̬,سɹ˵ */
				CH374DelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* ڼ⵽USB豸,ȴ100*50mS,ҪЩMP3̫,ڼ⵽USB豸DISK_MOUNTED,ȴ5*50mS,ҪDiskReady */
				for ( i = 0; i < 100; i ++ ) {  /* ȴʱ,100*50mS */
					CH374DelaymS( 50 );
					printf( "Ready ?\n" );
					if ( CH374DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
					if ( CH374DiskStatus < DISK_CONNECT ) {  /* ⵽Ͽ,¼Ⲣʱ */
						printf( "Device gone\n" );
						break;  /* µȴ */
					}
					if ( CH374DiskStatus >= DISK_MOUNTED && i > 5 ) break;  /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
					if ( CH374DiskStatus == DISK_CONNECT ) {  /* 豸 */
						if ( CH374vHubPortCount ) {  /* һUSB-HUB,ûU */
							printf( "No Udisk in USB_HUB\n" );
							break;
						}
						else {  /* δ֪USB豸,пU̷Ӧ̫,Ҫ */
						}
					}
				}
				if ( CH374DiskStatus >= DISK_MOUNTED ) {  /* U */
					break;  /* ʼU */
				}
				if ( CH374DiskStatus == DISK_CONNECT ) {  /* γԻǲ,ƲU */
					if ( CH374vHubPortCount ) {  /* һUSB-HUB,ûU */
/* whileеȴHUB˿U */
					}
					else {  /* δ֪USB豸,USB̡ӡ,Ѿ˺ܶλ */
						printf( "Unknown device\n" );
						goto UnknownUsbDevice;
					}
				}
			}
		}

		LED_OUT_ACT( );  /* LED */

		CH374DelaymS( 20 );

/* ѯ */
//		printf( "DiskSize\n" );
//		i = CH374DiskSize( );
//		mStopIfError( i );
//		printf( "TotalSize = %u MB \n", (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec * ( CH374vSectorSize / 512 ) >> 11 ) );  /* ʾΪMBΪλ */
		printf( "Current disk sector size = %d Bytes \n", CH374vSectorSize );  /* CH374vSectorSizeU̵ʵС */
		LED_RUN_ACT( );  /* ʼU */

		printf( "Check Disk Write Protect ? ...\n" );
		i = IsDiskWriteProtect( );  /* UǷд, ERR_SUCCESS˵д,0xFF˵ֻ/д,ֵ˵Ǵ */
		if ( i != ERR_SUCCESS && i != 0xFF ) {  /* ʧ */
			printf( "Again ...\n" );
			CH374DelaymS( 100 );
			i = IsDiskWriteProtect( );  /* һ */
		}
		if ( i == ERR_SUCCESS ) {  /* д */
			printf( "... No !\n" );
			LED_WR_ACT( );  /* д */
			printf( "Create a File\n" );
			strcpy( mCmdParam.Create.mPathName, "\\NEWFILE.TXT" );  /* ļ,ڸĿ¼ */
			i = CH374FileCreate( );  /* ½ļ,ļѾɾ½ */
			mStopIfError( i );
			mCmdParam.ByteWrite.mByteBuffer[0] = 'O';
			mCmdParam.ByteWrite.mByteBuffer[1] = 'K';
			mCmdParam.ByteWrite.mByteCount = 2;  /* дݵַ,ζдĳȲܳMAX_BYTE_IO,ڶεʱŸղŵд */
			i = CH374ByteWrite( );  /* ļд */
			mStopIfError( i );
			printf( "Close\n" );
			mCmdParam.Close.mUpdateLen = 0;  /* ҪԶļ,Զ,ôóCH374vSectorSizeı */
			i = CH374FileClose( );
			mStopIfError( i );
			LED_WR_INACT( );
			if ( SafeRemoveDisk( ) == ERR_SUCCESS ) {  /* ȫƳU */
				printf( "Safe Remove !\n" );
			}
			else {
				printf( "Unsafe Remove !\n" );
			}
		}
		else if ( i == 0xFF ) {  /* д */
			printf( "... Yes !\n" );
		}
		else {
			mStopIfError( i );  /* ʾ */
		}
		LED_RUN_INACT( );
UnknownUsbDevice:
		printf( "Take out\n" );
		while ( 1 ) {  /* ֧USB-HUB */
			CH374DelaymS( 10 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) != ERR_SUCCESS ) break;  /* ѯʽ: ǷӲ´״̬,سɹ˵ */
		}
		LED_OUT_INACT( );  /* LED */
		CH374DelaymS( 200 );
	}
}
