/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH374 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH374 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* MCS-51ƬCԵUļдʾ, 89C52߸ռĵƬ */
/* ʾCH374Uõ3˿ڸRoot-HUB,
   һ˿ȲUΪԴ,һ˿ںUΪĿ,Դ̵ļ*.TXTļƵĿ
*/
/* CH374INT#Ųòѯʽ, ݸƷʽΪ"DPTR", ٶȽ, MCS51Ƭ */


/* C51   CH374HFT.C */
/* LX51  CH374HFT.OBJ , CH374HF6.LIB, C51DPTR1.LIB */
/* OHX51 CH374HFT */

#include <reg52.h>
#include <stdio.h>
#include <string.h>

#define	MAX_BYTE_IO				35		/* ֽΪλζдļʱ󳤶,Ĭֵ29,ֵռڴ,ֵС򳬹óȱֶζд */

/* ¶ϸ˵뿴CH374HF6.Hļ */
#define LIB_CFG_INT_EN			0		/* CH374INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */

#define CH374_IDX_PORT_ADDR		0xBDF1	/* CH374˿ڵI/Oַ */
#define CH374_DAT_PORT_ADDR		0xBCF0	/* CH374ݶ˿ڵI/Oַ */
//#define CH374_IDX_PORT_ADDR		0xEFFF	/* CH374˿ڵI/Oַ */
//#define CH374_DAT_PORT_ADDR		0xE000	/* CH374ݶ˿ڵI/Oַ */
/* ֻʹõƬõ1KBⲿRAM: 0000H-01FFH Ϊ̶д, ֽΪλдļҪļݶдFILE_DATA_BUF */
#define	DISK_BASE_BUF_ADDR		0x0000	/* ⲿRAMĴݻʼַ,ӸõԪʼĻΪSECTOR_SIZE */

#define CH374_INT_WIRE			INT0	/* P3.2, INT0, CH374жINT#,CH374INT#,ڲѯж״̬ */
/* δCH374ж,ôӦȥ,ԶʹüĴѯʽ */

#define DISK_BASE_BUF_LEN		512		/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
/* ҪôݻԽԼRAM,ôɽDISK_BASE_BUF_LENΪ0Խֹ.Hļж建,ӦóڵCH375Init֮ǰõĻʼַpDISK_BASE_BUF */

#define NO_DEFAULT_CH374_F_ENUM		1		/* δCH374FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH374_F_QUERY	1		/* δCH374FileQueryʽֹԽԼ */
#define NO_DEFAULT_CH374_RESET		1		/* δCH374ResetʽֹԽԼ */

#define NO_DEFAULT_FILE_ENUMER		1		/* ֹĬϵļöٻص,бдĳ */

#include "..\CH374HF6.H"				/* Ҫ֧FAT32,ôѡCH374HF6.H */

UINT8X	FileName[0x20];			// ڸƵļ
UINT8X	LibSaveBuf[3][0x80];	// ڱӳĻ
UINT8X	my_buffer[0x7000];		// ʱת
UINT16	FileIndex, CountMatch;

/* P1.4һLEDڼʾĽ,͵ƽLED,U̲ */
sbit P1_4  = P1^4;
#define LED_OUT_INIT( )		{ P1_4 = 1; }	/* P1.4 ߵƽ */
#define LED_OUT_ACT( )		{ P1_4 = 0; }	/* P1.4 ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ P1_4 = 1; }	/* P1.4 ͵ƽLEDʾ */
sbit P1_5  = P1^5;
/* P1.5һLEDڼʾĽ,͵ƽLED,U̲ʱ */
#define LED_RUN_ACT( )		{ P1_5 = 0; }	/* P1.5 ͵ƽLEDʾ */
#define LED_RUN_INACT( )	{ P1_5 = 1; }	/* P1.5 ͵ƽLEDʾ */
sbit P1_6  = P1^6;
/* P1.6һLEDڼʾĽ,͵ƽLED,Uдʱ */
#define LED_WR_ACT( )		{ P1_6 = 0; }	/* P1.6 ͵ƽLEDʾ */
#define LED_WR_INACT( )		{ P1_6 = 1; }	/* P1.6 ͵ƽLEDʾ */

void	HostEnableRootHub( void );  // õRoot-HUB

void	RestoreDisk( UINT8 index );  // ָָU̵ı

void	SaveDisk( UINT8 index );  // ָU̵ı

void	HostEnableRootHub( void )  // õRoot-HUB
{
	CH374_WRITE_REGISTER( REG_USB_SETUP, BIT_SETP_HOST_MODE | BIT_SETP_AUTO_SOF );  // USBʽ,SOF
	CH374_WRITE_REGISTER( REG_HUB_SETUP, 0x00 );  // BIT_HUB_DISABLE,õROOT-HUB
	CH374_WRITE_REGISTER( REG_HUB_CTRL, 0x00 );  // ROOT-HUBϢ
}

void	RestoreDisk( UINT8 index )  // ָָU̵ı
{
	mCmdParam.SaveVariable.mSaveVariable = 0x80;  // ָU̵ı
	mCmdParam.SaveVariable.mBuffer = LibSaveBuf[ index ];  // 
	CH374SaveVariable( );	/* ָӳı,ӳڶCH374оƬ֮߶U֮л */
	CH374DirtyBuffer( );	/* ̻ */
}

void	SaveDisk( UINT8 index )  // ָU̵ı
{
	mCmdParam.SaveVariable.mSaveVariable = 1;  // ݱ
	mCmdParam.SaveVariable.mBuffer = LibSaveBuf[ index ];  // 
	CH374SaveVariable( );	/* ӳı,ӳڶCH374оƬ֮߶U֮л */
}

void xFileNameEnumer( void )			/* ļöٻصӳ,οCH374HF6.Hļе */
{  /* ÿһļFileOpenñصxFileNameEnumerغFileOpenݼCH374vFileSizeöֱļĿ¼ */
	UINT8			i, j, c;
	P_FAT_DIR_INFO	pFileDir;
	pFileDir = (P_FAT_DIR_INFO)( pDISK_BASE_BUF + CH374vFdtOffset );  /* ǰFDTʼַ */
	if ( pFileDir -> DIR_Attr & ATTR_DIRECTORY ) return;  /* Ŀ¼ */
	if ( pFileDir -> DIR_Name[0] == '.' ) return;  /* ǱϼĿ¼,붪 */
#ifndef	COPY_ANY_FILE  /* ˴Щļ,ʾֻ*.TXTļ */
	if ( pFileDir -> DIR_Name[8] != 'T' || pFileDir -> DIR_Name[9] != 'X' || pFileDir -> DIR_Name[10] != 'T' ) return;  /* ļչ,".TXT"ļ򲻴 */
#endif
	if ( CountMatch ++ < FileIndex ) return;  /* ָδ */
	for ( i = 0, j = 1; i < 11; i ++ ) {  /* ļ,Ϊ11ַ */
		c = pFileDir -> DIR_Name[ i ];
		if ( i == 0 && c == 0x05 ) c = 0xE5;  /* תַ */
		if ( c != 0x20 ) {  /* Чַ */
			if ( i == 8 ) FileName[j++] = '.';  /* չ,ӷָ */
			FileName[j++] = c;  /* ļһַ */
		}
	}
	FileName[j] = 0;  /* ǰļ·Ľ */
	FileName[0] = '/';  /* Ŀ¼µļ */
	CH374vFileSize = 1;  /* ǿǰö,FileOpenٻصxFileNameEnumerǰ */
}

/* ״̬,ʾ벢ͣ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
/* ,Ӧ÷ԼCH374DiskStatus״̬,CH374DiskConnectѯǰUǷ,UѶϿôµȴU̲ٲ,
   Ĵ:
   1һCH374DiskReady,ɹ,Open,Read/Write,CH374DiskReadyлԶCH374DiskConnect
   2CH374DiskReadyɹ,ôǿнCH374DiskStatusΪDISK_CONNECT״̬,Ȼͷʼ(ȴUCH374DiskConnectCH374DiskReady) */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		CH374DelaymS( 100 );
		LED_OUT_INACT( );
		CH374DelaymS( 100 );
	}
}

/* Ϊprintfgetkeyʼ */
void	mInitSTDIO( )
{
	SCON = 0x50;
	PCON = 0x80;
//	TL2 = RCAP2L = 0 - 10; /* 18.432MHz, 57600bps */
	TL2 = RCAP2L = 0 - 13; /* 24MHz, 57600bps */
	TH2 = RCAP2H = 0xFF;
	T2CON = 0x34;  /* ʱ2ڴڵĲʷ */
	TI = 1;
}

main( ) {
	UINT8	n, s;
	UINT8	SourceDisk, TargetDisk;
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	CH374DelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	mInitSTDIO( );  /* Ϊüͨڼʾ */

	printf( "Start\n" );

	s = CH374LibInit( );  /* ʼCH374CH374оƬ,ɹ0 */
	mStopIfError( s );
	HostEnableRootHub( );  // õRoot-HUB

	for ( n = 0; n < 3; n ++ ) {  // 3˿ڵUļ״̬,ÿU̸һ״̬
		SaveDisk( n );  // ӳı,ӳڶCH374оƬ֮߶U֮л
	}
	SourceDisk = 0xFF;
	TargetDisk = 0xFF;

/* ·ʼ */
	while ( 1 ) {  // ѭ
		CH374DelaymS( 10 );  /* ûҪƵѯ,,ÿmSѯһ豸 */
		for ( n = 0; n < 3; n ++ ) {  // ROOT-HUB˿
			RestoreDisk( n );  // ָָU̵ı
			CH374vEmbHubIndex = n + 1;  // CH374LIBʹ1/2/3ֱ0/1/2HUB˿
			if ( CH374DiskConnect( ) == ERR_SUCCESS ) {  /* ѯʽ: USB豸ǷӲ´״̬,سɹ˵ */
				if ( CH374EmbHubAttach( ) == BIT_HUB0_ATTACH	// 鵱ǰHUB˿,USB豸δ
					|| CH374DiskStatus <= DISK_CONNECT ) {   // ֮ǰ豸߸ղ豸δʼ
					LED_OUT_ACT( );
					CH374DelaymS( 200 );  // ȴUSB豸ϵȶ
/* UǷ׼,ЩU̲Ҫһ,ĳЩU̱Ҫִһܹ */
					CH374DiskStatus = DISK_CONNECT;  // ״̬Ա³ʼ(ǽһ˿ڵU̵״̬)
					for ( s = 0; s < 5; s ++ ) {  /* еUǷδ׼,Ա */
						CH374DelaymS( 100 );
						printf( "DiskReady ?\n" );
						if ( CH374DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
					}
					if ( CH374DiskStatus >= DISK_MOUNTED ) {  // ɹ,Ѿʼװϵͳ
						printf( "USB-Disk Ready\n" );
						if ( SourceDisk == 0xFF || SourceDisk == n ) {
							SourceDisk = n;  // ֮ǰûU̻U²
							TargetDisk = 0xFF;  // Դ,Ŀ
							FileIndex = 0;  // ָļ
						}
						else if ( TargetDisk == 0xFF || TargetDisk == n ) TargetDisk = n;
					}
					else CH374DiskStatus = 0xFF;  // ֵ֧USB豸
					LED_OUT_INACT( );
				}
				else {};  // Uһֱ,Ѿʼ,߲U豸
			}
			else {  // U̶Ͽ
				if ( n == SourceDisk ) SourceDisk = 0xFF;
				if ( n == TargetDisk ) TargetDisk = 0xFF;
			}
			SaveDisk( n );  // ָU̵ı
		}
		CH374DelaymS( 10 );  /* ûҪƵѯ,,ÿmSѯһ豸 */
		if ( SourceDisk != 0xFF && TargetDisk != 0xFF && SourceDisk != TargetDisk ) {  // U
			LED_RUN_ACT( );
			while ( 1 ) {
				RestoreDisk( SourceDisk );  // ָԴ̵ı
				if ( CH374DiskStatus < DISK_OPEN_FILE ) {  // ļδ
					printf( "Open source\n" );
					strcpy( mCmdParam.Open.mPathName, "\\*\xFF\x00" );  /* ļ,0xFFָʾ˵CH374vFileSize,0x00ڽstrcpy */
					CH374vFileSize = 0xFFFFFFFF;  /* ö,ÿҵһļһxFileNameEnumerصӳ,ֵС0x80000000ÿֻöһļ̫ */
					CountMatch = 0;  // ƥļ,ָűȽ
					s = CH374FileOpen( );  /* ö,ɻصxFileNameEnumer¼浽ṹ,ļкͨ*,Ϊļ */
					if ( s == ERR_SUCCESS ) s = ERR_FOUND_NAME;  // ת״̬,ͻ
					if ( ( s == ERR_FOUND_NAME || s == ERR_MISS_FILE ) && CountMatch > FileIndex ) {  // ҵָŵļ
						strcpy( mCmdParam.Open.mPathName, FileName );  // ļ
						s = CH374FileOpen( );  /* ҵļʽļ */
					}
					if ( s != ERR_SUCCESS ) {  // ߲ʧ
						if ( s == ERR_MISS_FILE ) printf( "Copy completion, %d files\n", FileIndex );  // 
						else printf( "FileOpen error %02x\n", (UINT16)s );
						SaveDisk( SourceDisk );  // Դ̵ı
						SourceDisk = 0xFF;
						break;
					}
					printf( "Open source [%s] ok\n", FileName );
				}
				mCmdParam.ReadX.mSectorCount = sizeof(my_buffer)/DISK_BASE_BUF_LEN;  // 
				mCmdParam.ReadX.mDataBuffer = &my_buffer[0];  /* ָļݻʼַ */
				CH374vFileSize += CH374vSectorSize - 1;  /* Ĭ,ʽȡʱ,޷ļβ1Ĳ,ԱʱӴļԶȡβͷ */
				s = CH374FileReadX( );  /* ļȡ */
				CH374vFileSize -= CH374vSectorSize - 1;  /* ָԭļ */
				if ( s != ERR_SUCCESS ) {  // ʧ
					printf( "FileReadX error %02x\n", (UINT16)s );
					SaveDisk( SourceDisk );  // Դ̵ı
					SourceDisk = 0xFF;
					break;
				}
				n = mCmdParam.ReadX.mSectorCount;  // ʵʶȡ
				if ( n == 0 ) {  // Դļ
					memset( & mCmdParam.Modify, 0xFF, sizeof( mCmdParam.Modify ) );
					s = CH374FileModify( );  // ѯǰļϢ
					memcpy( my_buffer, & mCmdParam.Modify, sizeof( mCmdParam.Modify ) );  // ļϢ
					if ( s == ERR_SUCCESS ) s = CH374FileClose( );  // رļ
					if ( s != ERR_SUCCESS ) {  // ʧ
						printf( "FileModify or FileClose error %02x\n", (UINT16)s );
						SaveDisk( SourceDisk );  // Դ̵ı
						SourceDisk = 0xFF;
						break;
					}
				}
				SaveDisk( SourceDisk );  // Դ̵ı
				LED_WR_ACT( );
				RestoreDisk( TargetDisk );  // ָĿ̵ı
				if ( CH374DiskStatus < DISK_OPEN_FILE ) {  // ļδ
					printf( "Create target\n" );
					strcpy( mCmdParam.Open.mPathName, FileName );  // ļ
					s = CH374FileCreate( );  /* ½ļ */
					if ( s != ERR_SUCCESS ) {  // ʧ
						printf( "FileCreate error %02x\n", (UINT16)s );
						SaveDisk( TargetDisk );  // Ŀ̵ı
						TargetDisk = 0xFF;
						break;
					}
					printf( "Create target ok\n" );
				}
				if ( n ) {  // 
					mCmdParam.WriteX.mSectorCount = n;  // 
					mCmdParam.WriteX.mDataBuffer = &my_buffer[0];  /* ָļݻʼַ */
					s = CH374FileWriteX( );  /* ļд */
					if ( s != ERR_SUCCESS || mCmdParam.WriteX.mSectorCount != n ) {  // ʧ
						if ( s == ERR_SUCCESS ) printf( "Write sector count error\n" );
						else printf( "FileWriteX error %02x\n", (UINT16)s );
						SaveDisk( TargetDisk );  // Ŀ̵ı
						TargetDisk = 0xFF;
						break;
					}
					printf( "." );  // ָʾ
				}
				else {  // ļ
					memcpy( & mCmdParam.Modify, my_buffer, sizeof( mCmdParam.Modify ) );  // ļϢ
					s = CH374FileModify( );  // õǰļϢ
					mCmdParam.Close.mUpdateLen = 0;  /* ֹ³ */
					if ( s == ERR_SUCCESS ) s = CH374FileClose( );  // رļ
					if ( s != ERR_SUCCESS ) {  // ʧ
						printf( "FileModify or FileClose error %02x\n", (UINT16)s );
						SaveDisk( TargetDisk );  // Ŀ̵ı
						TargetDisk = 0xFF;
						break;
					}
					printf( "Close target ok\n" );
					FileIndex ++;  // һļ
				}
				SaveDisk( TargetDisk );  // Ŀ̵ı
				LED_WR_INACT( );
			}
			LED_RUN_INACT( );
		}
	}
}
