/* SPIӿӳ,CH374ӳ */

UINT8	CH374_READ_REGISTER( UINT8 mAddr )  /* ⲿıCH374õӳ,ָĴȡ */
{
	UINT8	d;
	Spi374Start( mAddr, CMD_SPI_374READ );
	d = Spi374InByte( );
	Spi374Stop( );
	return( d );
}

void	CH374_WRITE_REGISTER( UINT8 mAddr, UINT8 mData )  /* ⲿıCH374õӳ,ָĴд */
{
	Spi374Start( mAddr, CMD_SPI_374WRITE );
	Spi374OutByte( mData );
	Spi374Stop( );
}

void	CH374_READ_BLOCK( UINT8 mAddr, UINT8 mLen, PUINT8X mBuf )  /* ⲿıCH374õӳ,ָʼַݿ */
{
	Spi374Start( mAddr, CMD_SPI_374READ );
	while ( mLen -- ) *mBuf++ = Spi374InByte( );
	Spi374Stop( );
}

void	CH374_WRITE_BLOCK( UINT8 mAddr, UINT8 mLen, PUINT8X mBuf )  /* ⲿıCH374õӳ,ָʼַдݿ */
{
	Spi374Start( mAddr, CMD_SPI_374WRITE );
	while ( mLen -- ) Spi374OutByte( *mBuf++ );
	Spi374Stop( );
}

PUINT8X	CH374_READ_BLOCK64( UINT8 mAddr, PUINT8X mBuf )  /* ⲿıCH374õӳ,˫64ֽڵݿ,صǰַ */
{
	UINT8	i;
	Spi374Start( mAddr, CMD_SPI_374READ );
	for ( i = CH374_BLOCK_SIZE; i != 0; i -- ) *mBuf++ = Spi374InByte( );
	Spi374Stop( );
	return( mBuf );
}

PUINT8X	CH374_WRITE_BLOCK64( UINT8 mAddr, PUINT8X mBuf )  /* ⲿıCH374õӳ,˫д64ֽڵݿ,صǰַ */
{
	UINT8	i;
	Spi374Start( mAddr, CMD_SPI_374WRITE );
	for ( i = CH374_BLOCK_SIZE; i != 0; i -- ) Spi374OutByte( *mBuf++ );
	Spi374Stop( );
	return( mBuf );
}

void	CH374_WRITE_BLOCK_C( UINT8 mLen, PUINT8C mBuf )  /* ⲿıCH374õӳ,RAM_HOST_TRANд볣ݿ */
{
	Spi374Start( RAM_HOST_TRAN, CMD_SPI_374WRITE );
	do {
		Spi374OutByte( *mBuf );
		mBuf ++;
	} while ( -- mLen );
	Spi374Stop( );
}
